unit TestButtons;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Interfaces, fpcunit, forms,
  testregistry, testutils, u_buttons_appli;

type

  { TTestForm }

  TTestForm = class(TForm)
    Bouton : TMyClose;
  public
    procedure DoClose ( var AAction : TCloseAction ); override;
    procedure RunBouton;
  End;
  { TTestButtons }
  TTestButtons= class(TTestCase)
  protected
    procedure SetUp; override; 
    procedure TearDown; override; 
  published
    Procedure Tests;
    procedure TestHookUp;
  end;

var TestForm : TTestForm;


implementation


{ TTestForm }

procedure TTestForm.DoClose(var AAction: TCloseAction);
begin
  inherited DoClose(AAction);
  AAction := caHide;
end;

procedure TTestForm.RunBouton;
begin
  Bouton := TMyClose.Create(Self);
end;

{ TTestButtons }

procedure TTestButtons.TestHookUp; 
begin
  Fail('Write your own test'); 
end; 

procedure TTestButtons.SetUp; 
begin
  // Initialize
  TestForm := TTestForm.Create(nil);
  TestForm.RunBouton;
  TestForm.Show;

end; 

procedure TTestButtons.Tests;
begin
  SetUp;
  // testing
  AssertTrue('Testing Glyph of TMyClose',assigned(TestForm.Bouton.Glyph));
  AssertTrue('TestForm of TMyClose visible',TestForm.Visible);
  TestForm.Bouton.Click;
  AssertFalse('TestForm of TMyClose not visible',TestForm.Visible);
  TearDown;
end;


procedure TTestButtons.TearDown;
begin
  // Freeing
  TestForm.Free;
end;

initialization
  RegisterTest(TTestButtons);
end.

