unit fonctions_sqldb;

{$mode objfpc}{$H+}

interface

uses
  Classes, db, SysUtils, ExtData;

function fs_InsereCompteur ( const adat_Dataset, adat_DatasourceIncCompteur : TDataset ;
                             const astl_Cle : TStringList ;
                             const as_ChampCompteur, as_Table : String ;
                             const ali_Debut, ali_LimiteRecherche     : Int64 ;
                             const lb_DBMessageOnError : Boolean ;
                                   lb_SetField  : Boolean ;
                             var   li_Compteur : Int64 ): String;

implementation

uses TypInfo, Variants, StrUtils;


// récupère une propriété d'objet
// aComp_ComponentToSet : Composant cible
// as_PropertyName      : Propriété cible
// a_ValueToSet         : Valeur à affecter
function fobj_getComponentObjectProperty ( const aComp_Component : TComponent ; const as_PropertyName : String ) : TObject ;
Begin
  Result := nil ;
  if   assigned ( GetPropInfo ( aComp_Component, as_PropertyName ))
  and  PropIsType      ( aComp_Component, as_PropertyName , tkClass)
  then Result := GetObjectProp   ( aComp_Component, as_PropertyName );
End ;

function fb_GetParamsDataset (const adat_ADataset : Tdataset ;var aprs_ParamSource: TParams {$IFDEF EADO} ; var aprs_ParamterSource: TParameters {$ENDIF}): Boolean;
var lobj_SQL : TObject ;
begin
  Result := false;
  aprs_ParamSource := nil;
{$IFDEF EADO}
  aprs_ParamterSource := nil;
{$ENDIF}
  lobj_SQL := fobj_getComponentObjectProperty (adat_ADataset, 'Params' );
  if ( lobj_SQL is TParams ) Then
    Begin
      aprs_ParamSource:= lobj_SQL as TParams ;
      Result := True
    end
{$IFDEF EADO}
  else
    Begin
       lobj_SQL := fobj_getComponentObjectProperty ( adat_ADataset, 'Parameters' );
       if ( lobj_SQL is TParameters ) Then
         Begin
           aprs_ParamterSource := lobj_SQL as TParameters ;
           Result := True
         End;
    End
{$ENDIF};
end;


procedure p_SetSQLQuery ( const adat_Dataset : Tdataset ; const as_Query : {$IFDEF DELPHI_9_UP} String {$ELSE} WideString{$ENDIF});
var lobj_SQL : TObject ;
    lprm_Params : TParams ;
    {$IFDEF EADO}
    lprm_Parameters : TParameters ;
    {$ENDIF}
Begin
 lobj_SQL := fobj_getComponentObjectProperty ( adat_Dataset, 'SQL' );
 if assigned ( lobj_SQL ) Then
   Begin
     fb_GetParamsDataset ( adat_Dataset, lprm_Params{$IFDEF EADO}, lprm_Parameters {$ENDIF});
     if assigned ( lprm_Params ) then
       lprm_Params.Clear;
     {$IFDEF EADO}
     if assigned ( lprm_Parameters ) then
       lprm_Parameters.Clear;
     {$ENDIF}
     if ( lobj_SQL is TStrings ) Then
      with lobj_SQL as TStrings do
       Begin
         BeginUpdate ;
         Text := as_query ;
         EndUpdate ;
       End
{$IFDEF DELPHI_9_UP}
      else if ( lobj_SQL is TWideStrings ) Then
       with lobj_SQL as TWideStrings do
        Begin
          Beginupdate;
          Text := as_query ;
          EndUpdate;
        End;
{$ENDIF}
   ;
   End;
End ;

procedure p_OpenSQLQuery ( const adat_Dataset : Tdataset ; const as_Query : {$IFDEF DELPHI_9_UP} String {$ELSE} WideString{$ENDIF} );
Begin
  if assigned ( adat_Dataset ) Then
    Begin
      p_SetSQLQuery ( adat_Dataset, as_Query );
      adat_Dataset.Open;
    End ;
End ;

////////////////////////////////////////////////////////////////////////////////
// fonction : fs_RemplaceChar
// Description : Remplace un caractère par un autre dans une chaîne
// as_Texte       : Le texte à modifier
// ach_Origine    : Le caractère à remplacer
// ach_Voulu      : Le caractère de remplacement
// Résultat       : la chaîne avec le caractère de remplacement
////////////////////////////////////////////////////////////////////////////////
function fs_RemplaceChar   ( const as_Texte : String ; ach_Origine, ach_Voulu : Char ) : String ;
var li_i : Longint ;
Begin
  Result := '' ;
  for li_i := 1 to length ( as_Texte ) do
    if as_Texte [ li_i ] = ach_Origine Then
      Result := Result + ach_Voulu
    Else
      Result := Result + as_Texte [ li_i ];
End ;

///////////////////////////////////////////////////////////////////////////////
// Fonction : fs_stringDbQuote
// Description : Cette fonction permet de faire le doublement des ' dans une chaîne de caractères
// as_Texte : Le texte avec des ' éventuels
// Résultat : Le texte avec des '' à la place de '
///////////////////////////////////////////////////////////////////////////////
function fs_stringDbQuote ( const as_Texte: string): string;
begin
  result :=AnsiReplaceStr ( as_Texte, '''' , '''''' );
end;





function fs_AjouteRechercheClePrimaire ( const adat_Dataset         : TDataset    ;
                                         const as_ChampsClePrimaire : TStringList ;
                                         const avar_ValeursCle      : Variant     ;
                                         const as_ChampExclu        : String      ): String ;

var
    ls_EnrChamp  : String ;
    lvar_Valeur  : Variant ;
    li_i         : Integer ;
    lb_First     : Boolean ;
    ls_SQL       : WideString;
Begin
  Result := '' ;
  lb_First     := True ;
  for li_i := 0 to as_ChampsClePrimaire.Count - 1 do
    if as_ChampExclu <> as_ChampsClePrimaire [ li_i ] Then
      Begin
        if  ( adat_Dataset.State <> dsInsert ) Then
          Begin
            if VarIsArray ( avar_ValeursCle ) Then
              Begin
                if  ( li_i >= varArrayLowBound  ( avar_ValeursCle, 1 ))
                and ( li_i <= varArrayHighBound ( avar_ValeursCle, 1 ))
                and ( avar_ValeursCle [ li_i ] <> Null ) Then
                  lvar_Valeur := avar_ValeursCle [ li_i ]
                Else
                  lvar_Valeur := Null ;
              End
            Else lvar_Valeur := avar_ValeursCle ;
            if  ( lvar_Valeur <> Null )
            and ( adat_Dataset.State = dsEdit )
            and ( Trim ( adat_Dataset.FindField ( as_ChampsClePrimaire [ li_i ] ).AsString ) <> Trim ( VarToStr( lvar_Valeur ))) Then
              Begin
                lvar_Valeur := adat_Dataset.FindField ( as_ChampsClePrimaire [ li_i ] ).Value ;
              End ;
          End
        Else
          Begin
            lvar_Valeur := adat_Dataset.FindField ( as_ChampsClePrimaire [ li_i ] ).Value ;
          End ;
        if lvar_Valeur = Null Then
          ls_EnrChamp := 'NULL'
        Else
          if VarIsFloat ( lvar_Valeur ) Then
            ls_EnrChamp := fs_RemplaceChar ( FloatToStr( lvar_Valeur ), ',', '.' )
        Else
          ls_EnrChamp := fs_RemplaceChar ( VarToStr( lvar_Valeur ), ',', '.' ) ;
        if lb_First then
          ls_SQL := ' WHERE '
         Else
          ls_SQL := ' AND ' ;
        if  ( adat_Dataset.FindField ( as_ChampsClePrimaire [ li_i ] ) <> nil              )
        and ( adat_Dataset.FindField ( as_ChampsClePrimaire [ li_i ] ).DataType = ftString )
        and ( adat_Dataset.FindField ( as_ChampsClePrimaire [ li_i ] ).Value <> Null       )
         Then ls_SQL := ls_SQL + as_ChampsClePrimaire [ li_i ] + '=''' + fs_stringDbQuote ( ls_EnrChamp ) + ''''
         else ls_SQL := ls_SQL + as_ChampsClePrimaire [ li_i ] + '='   +                    ls_EnrChamp ;
       Result := ls_SQL ;
       lb_First     := False ;
      End ;
End ;



/////////////////////////////////////////////////////////////////////////////////
// Fonction : fb_InsereCompteur
// Description : Compteur sur un champ numérique ou chaîne
// Paramètres : adat_Dataset : Le dataset du compteur
//              astl_Cle     : La clé du dataset
//              as_ChampCompteur : Le champ compteur dans la clé
//              as_Table         : La table du compteur
//              ali_Debut        : Le compteur
//              ali_LimiteRecherche : Le maximum du champ compteur
/////////////////////////////////////////////////////////////////////////////////
function fs_InsereCompteur ( const adat_Dataset, adat_DatasourceIncCompteur : TDataset ;
                             const astl_Cle : TStringList ;
                             const as_ChampCompteur, as_Table : String ;
                             const ali_Debut, ali_LimiteRecherche     : Int64 ;
                             const lb_DBMessageOnError : Boolean ;
                                   lb_SetField  : Boolean ;
                             var   li_Compteur : Int64 ): String;
var li64_Terminus     ,
    li64_Compteur     ,
    li64_Compteur2    : Int64 ;
    li_i              : Integer ;
    ls_ChampLettrage  : String ;
    lvar_Cle          : Variant ;
    lch_Lettrage      ,
    lch_Lettrage2     : Char ;
    ls_SQL, ls_SQL2 : WideString ;
Begin
  Result := '' ;
  if ( adat_Dataset.State in [dsInsert,dsEdit] ) or ( adat_Dataset.FieldByName ( as_ChampCompteur ).AsCurrency < ali_Debut )  then
    begin
      if  ( adat_Dataset.FieldByName ( as_ChampCompteur ) is TNumericField )
       Then
        begin
          adat_DatasourceIncCompteur.Close;
          // sélectionner le compteur maximum
          ls_SQL := 'SELECT MAX(' + as_ChampCompteur + ') FROM ' + as_Table ;
          ls_SQL2 := fs_AjouteRechercheClePrimaire ( adat_Dataset, astl_Cle, lvar_Cle, as_ChampCompteur );
          if ls_SQL2 > '' Then
            ls_SQL := ls_SQL + ls_SQL2 + ' AND '   + as_ChampCompteur + '<=' + IntToStr ( ali_LimiteRecherche )
          Else
            ls_SQL := ls_SQL + ' WHERE ' + as_ChampCompteur + '<=' + IntToStr ( ali_LimiteRecherche );
          try
             p_OpenSQLQuery ( adat_DatasourceIncCompteur, ls_SQL );
          finally
          End;
          try
            // Incrémenter le compteur si c'est possible
            if ( ali_LimiteRecherche = ali_Debut ) // annuler les limites si elles sont égales
            or ( adat_DatasourceIncCompteur.Fields[0].Value < ali_LimiteRecherche ) Then // Limite supérieure uniquement à cause du MAX
              Begin
                if adat_DatasourceIncCompteur.Fields[0].Value >= ali_Debut then
                  li_Compteur :=
                    adat_DatasourceIncCompteur.Fields[0].Value + 1
                else
                  li_Compteur := ali_Debut;
              End
            Else
            // Sinon scrute le dataset à la recherche d'un compteur
              Begin
                adat_DatasourceIncCompteur.Close;
                ls_SQL := 'SELECT ' + as_ChampCompteur + ' FROM ' + as_Table ;
                ls_SQL := ls_SQL + fs_AjouteRechercheClePrimaire ( adat_Dataset, astl_Cle, lvar_Cle, as_ChampCompteur );
                ls_SQL := ls_SQL + ' ORDER BY ' + as_ChampCompteur ;
                p_OpenSQLQuery ( adat_DatasourceIncCompteur, ls_SQL );
                li64_Compteur := ali_Debut ;
                if not adat_DatasourceIncCompteur.IsEmpty Then
                  with adat_DatasourceIncCompteur do
                    if Fields [ 0 ].Value <= li64_Compteur Then
                      while not eof do
                        Begin
                          li64_Compteur := Fields [ 0 ].Value ;
                          Next ;
                          if  not eof  Then
                            Begin
                              if ( adat_DatasourceIncCompteur.Fields [ 0 ].Value > li64_Compteur + 1 ) Then
                                Begin
                                  li_Compteur := li64_Compteur + 1 ;
                                  Break ;
                                End ;
                            End
                          Else
                            li_Compteur := li64_Compteur + 1 ;
                        End
                    Else
                      li_Compteur := li64_Compteur
                Else
                 lb_SetField := False;
              End ;

            adat_DatasourceIncCompteur.Close;
          Except
            On E:Exception do
              Result := E.Message;
          End ;
        end;
    end;
  if ( lb_SetField )
  and ( li_Compteur <> -1 )Then
    adat_Dataset.FieldByName ( as_ChampCompteur ).Value := li_Compteur;
End ;
end.

