unit u_form;

interface

uses
  SysUtils, Classes, sqldb, db, sqlite3conn, FileUtil,
{$IFDEF UseRuntime}
  Ext, ExtPascal, ExtForm,
  ExtData, ExtGrid, ExtUtil, ExtAir, ExtDd, 
  ExtMenu,  ExtState;

type
  {$M+}
  TExtPanel_Tab = TExtPanel; 
  TExtFormTextField_Grid = TExtFormTextField; 
  TExtFormNumberField_Grid = TExtFormNumberField; 
  TExtFormDateField_Grid = TExtFormDateField; 
  TExtFormTimeField_Grid = TExtFormTimeField; 
  TExtFormCheckbox_Grid = TExtFormCheckbox; 
  TExtFormComboBox_Grid = TExtFormComboBox; 
  {$M-}

{$ELSE}
  ExtP_Design_Ctrls, ExtP_Design_Grid;
{$ENDIF}

type

  { TExample }

  TExample = class(TExtWindow)
    Ajouter: TExtButton;
    Effacer: TExtButton;
    Ouvrir: TExtButton;
    SQLite3Connection: TSQLite3Connection;
    SQLTransaction: TSQLTransaction;
    SQLUtilisateur: TSQLQuery;
    SQLTool: TSQLQuery;
    tf_nom: TExtFormTextField;
    tf_prenom: TExtFormTextField;
    lab_Prenom: TExtFormLabel;
    gd_Utilisateurs: TExtGridEditorGridPanel;
    lab_Nom: TExtFormLabel;
    tgd_Nom: TExtFormTextField_Grid;
    tgd_Prenom: TExtFormTextField_Grid;
    Utilisateurs: TExtPanel_Tab;
    ExtTabPanel1: TExtTabPanel;
    procedure AjouterClick;
    procedure EffacerClick;
    procedure OuvrirClick;
    procedure GridRowClick(This : TExtGridGridPanel; ARowIndex : Integer; E : TExtEventObjectSingleton);
  private
    gstl_CleUtilisateur : TStringList ;
    gi_RowIndex : Longint;
    gas_Enregistrements: TExtDataArrayStore ;
    function CreeChaineAjax(const s: String): String;
    procedure p_CreeChaineEnregistrements ( var chaine : String ); overload;
    procedure AjouterElements;
    procedure p_CreeChaineEnregistrements(var chaine : String ; const s_Nom, s_Prenom, s_cle: String); overload;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Show;
  published
    procedure CloseAjax;
  end;

implementation

uses
  fonctions_sqldb;

procedure TExample.AjouterClick;
Var chaine : String ;
    Compteur : Int64;
    s_Records : String;
begin
  if ( tf_nom.JsString ( tf_nom.GetValue ) = '') Then
    Begin
      ExtMessageBox.Alert('Erreur', JsString ( tf_nom.GetValue )+'Impossible d''enregistrer : '+#13#10 + 'Il n''y a pas de nom d''utilisateur.');
      Exit;
    End;
  with SQLUtilisateur do
    try
      Insert;
      FieldByName('PRENOM').AsString := JsString ( tf_prenom.GetValue );
      FieldByName('NOM'   ).AsString := JsString ( tf_nom   .GetValue );
      Post;
      ApplyUpdates;
      SQLTransaction.CommitRetaining;
    Except
      On e: Exception do
       with SQLUtilisateur do
         Begin
          ExtMessageBox.Alert('Erreur', 'Impossible d''enregistrer : '+#13#10+e.Message, Ajax(CloseAjax, ['OK', '%0']));
          Exit;
         end;
    End;
  s_records := '';
  p_CreeChaineEnregistrements ( s_Records, JsString ( tf_nom   .GetValue ), JsString ( tf_prenom.GetValue ), IntTostr ( Compteur ) );
    try
      gd_Utilisateurs.SetDisabled(True);
      TExtDataArrayStore(gd_Utilisateurs.GetStore ).Insert(0, JSArray('new Ext.data.Record ("'+JsString ( tf_nom   .GetValue )+'","'+JsString ( tf_prenom.GetValue )+'")'));
    finally
      gd_Utilisateurs.SetDisabled(False);
    end;
End;

procedure TExample.EffacerClick;
var datastore: TExtDataStore;
    datarecord : TExtDataRecord;
    ATemp : String ;
begin
  datastore := TExtDataStore ( gd_Utilisateurs.GetStore );
  ATemp := JSString(datastore.GetCount );
  if SQLUtilisateur.Active
  and not SQLUtilisateur.IsEmpty
  and ( gi_RowIndex >= 0 )
  and ( gi_RowIndex < StrToInt(ATemp))
    Then
      Begin
        datastore := TExtDataStore ( gd_Utilisateurs.GetStore );
        ATemp := JsString(TExtDataRecord(datastore.GetAt( gi_RowIndex )).Get('Clep'));
        SQLTool.SQL.Text := 'DELETE FROM UTILISATEUR WHERE CLEP='+ATemp;
        SQLTool.ExecSQL;
        SQLTransaction.CommitRetaining;
        with gd_Utilisateurs do
          Begin
            setDisabled ( True );
            datastore := TExtDataStore ( GetStore );
            datarecord := TExtDataRecord(datastore.GetAt( gi_RowIndex ));
            datastore := TExtDataStore ( GetStore );
            datastore.remove ( datarecord );
            Reconfigure ( datastore, TExtGridColumnModel(ColModel) );
            setDisabled ( False );
          end;
      End;
end;

procedure TExample.OuvrirClick;
begin
  AjouterElements;//ExtMessageBox.Alert('Erreur', gas_Enregistrements.Data.Objects[0].JSName);
  SQLUtilisateur.Params.Clear;
  with SQLUtilisateur.Params.Add as TParam do
    Begin
      DataType := ftInteger;
      ParamType := ptInputOutput;
      Name := 'CLEP';
    End;
  with SQLUtilisateur.Params.Add as TParam do
    Begin
      DataType := ftString;
      ParamType := ptInputOutput;
      Name := 'NOM';
    End;
  with SQLUtilisateur.Params.Add as TParam do
    Begin
      DataType := ftString;
      ParamType := ptInputOutput;
      Name := 'PRENOM';
    End;
end;

procedure TExample.GridRowClick(This: TExtGridGridPanel; ARowIndex: Integer;
  E: TExtEventObjectSingleton);
begin
  gi_RowIndex := ARowIndex;
end;

{
      ExtMessageBox.Alert('Erreur', 'Impossible d''enregistrer : '+#13#10 + 'Il n''y a pas de nom d''utilisateur.');

End;
 }

constructor TExample.Create;
Begin
  inherited;
{$IFDEF UseRuntime}
 {$I *.inc}
  gi_RowIndex := -1 ;
  gd_Utilisateurs.StripeRows:=True;
  SQLite3Connection := TSQLite3Connection.Create(nil);
  SQLite3Connection.DatabaseName :=IncludeTrailingPathDelimiter(GetAppConfigDirUTF8(False))+'mabaseweb.db';
  SQLite3Connection.charset:= 'UTF-8' ;
  SQLTransaction := TSQLTransaction.Create(nil);
  SQLTransaction.Database := SQLite3Connection;
  SQLTransaction.Action := caCommitRetaining;
  SQLTool        := TSQLQuery.Create(nil);
  SQLTool       .Transaction := SQLTransaction;
  SQLTool       .Database := SQLite3Connection;
  SQLUtilisateur := TSQLQuery.Create(nil);
  SQLUtilisateur.Transaction := SQLTransaction;
  SQLUtilisateur.Database := SQLite3Connection;
  SQLUtilisateur.SQL.Text := 'SELECT * FROM UTILISATEUR' ;
  SQLUtilisateur.InsertSQL.Text := 'INSERT INTO UTILISATEUR (CLEP,NOM,PRENOM) VALUES (:CLEP,:NOM,:PRENOM)';
  SQLUtilisateur.UpdateSQL.Text := 'UPDATE UTILISATEUR SET NOM=:Nom,PRENOM=:Prenom WHERE CLEP=:Clep';
  SQLUtilisateur.DeleteSQL.Text := 'DELETE FROM UTILISATEUR WHERE CLEP=:Clep';
  gstl_CleUtilisateur := TStringList.Create();
  gstl_CleUtilisateur.Add ( 'CLEP' );
  gd_Utilisateurs.OnRowClick := GridRowClick;
{$ENDIF}
end;

destructor TExample.Destroy;
begin
  inherited;
{$IFDEF UseRuntime}
  SQLite3Connection.Free;
  SQLTransaction.Free;
  SQLUtilisateur.Free;
  gas_Enregistrements.free;
  gstl_CleUtilisateur.Free;
{$ENDIF}
end;

procedure TExample.p_CreeChaineEnregistrements ( var chaine : String );
begin
  p_CreeChaineEnregistrements ( chaine, SQLUtilisateur.FieldByName('Nom').AsString, SQLUtilisateur.FieldByName('Prenom').AsString, SQLUtilisateur.FieldByName('Clep').AsString );
  SQLUtilisateur.Next;
End;

function TExample.CreeChaineAjax ( const s : String ):String;
Begin
  // Le code Javascript affiche les chaines entre des guillemets
  Result := StringReplace(s,'"','\"', [rfReplaceAll]);
end;

procedure TExample.p_CreeChaineEnregistrements(var chaine: String; const s_Nom,
  s_Prenom, s_cle : String);
begin
  if chaine > '' Then
    chaine := chaine + ',' ;
  chaine := chaine + '["' + CreeChaineAjax (s_Nom) + '","' + CreeChaineAjax (s_Prenom)+ '","' + s_Cle+ '"]' ;
End;

procedure TExample.AjouterElements;
var i : Longint ;
    s_Records : String;
begin
  try
   SQLUtilisateur.First;

   // Création du tableau
   while not SQLUtilisateur.EOF do
      Begin
        p_CreeChaineEnregistrements ( s_Records );
      End;
  Except
    On e: Exception do
      ExtMessageBox.Alert('Erreur', 'Problème de gestion des données : '+#13#10+e.Message, Ajax(CloseAjax, ['OK', '%0']));
  End;
  // Création d'un tableau AJAX
  gas_Enregistrements:= TExtDataArrayStore.Create;
  With gas_Enregistrements Do
   Begin
   //Création de la structure de données
     with TExtDataField.AddTo(Fields) do Begin TypeJS := 'String'; Name :='Nom'; End;
     with TExtDataField.AddTo(Fields) do Begin TypeJS := 'String'; Name :='Prenom'; End;
     with TExtDataField.AddTo(Fields) do Begin TypeJS := 'Integer'; Name :='Clep'; End;
//     ExtMessageBox.Alert('Erreur', 'Impossible d''enregistrer : '+#13#10 + 'Il n''y a pas de nom d''utilisateur.');
    end;
  gas_Enregistrements.Data:=gas_Enregistrements.JSArray(s_Records,True); // Affectation des gas_Enregistrements
  with gd_Utilisateurs do
    Begin
      SetDisabled(True);
      Reconfigure(gas_Enregistrements, TExtGridColumnModel(ColModel));
      SetDisabled(False);
    end;
  ExtMessageBox.Alert('Erreur', s_Records);
end;

procedure TExample.Show;
begin
  inherited Show; 
  try
    SQLTransaction.Active := True;
    SQLUtilisateur.Open;
  Except
    On e: Exception do
      ExtMessageBox.Alert('Erreur', 'Problème de connexion à ' + SQLite3Connection.DatabaseName +' : '+#13#10+e.Message, Ajax(CloseAjax, ['OK', '%0']));
  End;
end;



procedure TExample.CloseAjax;
begin
  Close;
end;

end.

