unit UFiche;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Grids;

const CST_EXTENSION_CSV  = '.csv' ;
      CST_SEPARATEUR_CSV = ';' ;

type

  { TMaFiche }

  TMaFiche = class(TForm)
    Noms: TStringGrid;
    Quitter: TToggleBox;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure QuitterChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  MaFiche: TMaFiche;

implementation

uses GDBTypeInfo, LazUTF8,LazUTF8Classes,LazFileUtils;

{ TMaFiche }

procedure TMaFiche.FormShow(Sender: TObject);
var stl_FichierCSV : TStringListUTF8 ;
    ls_uneligne : String;
    li_i, li_j : Integer;
    gdt_LigneCSV : TGDBTypes ;
begin
  if FileExistsUTF8(Application.ExeName + CST_EXTENSION_CSV) Then
    Begin
      stl_FichierCSV := TStringListUTF8.Create ( );
        try
          stl_FichierCSV.LoadFromFile ( Application.ExeName + CST_EXTENSION_CSV );
        Except
          On E:Exception do
            Showmessage ( 'Impossible de lire le fichier ' +  Application.ExeName + CST_EXTENSION_CSV + ':'+#13#10 + E.Message );
        end;
    End
   else
    Exit;
  if stl_FichierCSV.Count = 0 Then
    Exit;

  gdt_LigneCSV := TGDBTypes.CreateFromCSV(stl_FichierCSV [ 0 ]);
  {
  GDBTypeInfo.FKind := skSimple;
    GDBType.FTypeName := GetPart([], [', '], AValues);
   }
  // Sauvegarde des noms de colonnes : Nous ne sommes pas obligés de le faire
  for li_i := 0 to gdt_LigneCSV.Count -1 do
    Begin
      if li_i = 0 Then // La première ligne ne possède pas de séparateur
        ls_uneligne := Noms.Columns [ li_i ].Title.Caption
       Else
        ls_uneligne := ls_uneligne + CST_SEPARATEUR_CSV + Noms.Columns [ li_i ].Title.Caption;
    end;
  stl_FichierCSV.Add(ls_uneligne);
  // Le tableau a des colonnes mais aussi des lignes
  // Noms.FixedRows est une colonne qui n'est pas modifiable
  for li_j := Noms.FixedRows to Noms.RowCount -1 do
    Begin
    // Sauvegarde des lignes de la grille
      for li_i := Noms.FixedCols to Noms.Columns.Count -1 do
        Begin
          if li_i = 0 Then // La première ligne ne possède pas de séparateur
            ls_uneligne := Noms.Cells [ li_i, li_j ]
           Else
            ls_uneligne := ls_uneligne + CST_SEPARATEUR_CSV + Noms.Cells [ li_i, li_j ];
        end;
      stl_FichierCSV.Add(ls_uneligne);
    end;
  stl_FichierCSV.Free;
end;

procedure TMaFiche.QuitterChange(Sender: TObject);
begin
  Close;
end;

procedure TMaFiche.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var stl_FichierCSV : TStringListUTF8 ;
    ls_uneligne : String;
    li_i, li_j : Integer;
begin
  // Pas de colonne donc pas de ligne donc on quitte
  if Noms.Columns.Count = 0 Then
    Exit;

  stl_FichierCSV := TStringListUTF8.Create (  );

  // Sauvegarde des noms de colonnes : Nous ne sommes pas obligés de le faire
  for li_i := 0 to Noms.Columns.Count -1 do
    Begin
      if li_i = 0 Then // La première ligne ne possède pas de séparateur
        ls_uneligne := Noms.Columns [ li_i ].Title.Caption
       Else
        ls_uneligne := ls_uneligne + CST_SEPARATEUR_CSV + Noms.Columns [ li_i ].Title.Caption;
    end;
  stl_FichierCSV.Add(ls_uneligne);
  // Le tableau a des colonnes mais aussi des lignes
  // Noms.FixedRows est une colonne qui n'est pas modifiable
  for li_j := Noms.FixedRows to Noms.RowCount -1 do
    Begin
    // Sauvegarde des lignes de la grille
      for li_i := Noms.FixedCols to Noms.Columns.Count -1 do
        Begin
          if li_i = 0 Then // La première ligne ne possède pas de séparateur
            ls_uneligne := Noms.Cells [ li_i, li_j ]
           Else
            ls_uneligne := ls_uneligne + CST_SEPARATEUR_CSV + Noms.Cells [ li_i, li_j ];
        end;
      stl_FichierCSV.Add(ls_uneligne);
    end;
  try
    stl_FichierCSV.SaveToFile(Application.ExeName + CST_EXTENSION_CSV);
  Except
    On E:Exception do
      Showmessage ( 'Impossible d''écrire dans le fichier ' +  Application.ExeName + CST_EXTENSION_CSV + ':'+#13#10 + E.Message );
  End;
  stl_FichierCSV.Free;

end;

initialization
  {$I ufiche.lrs}

end.

