unit UFiche;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, SdfData, db, dbf, FileUtil, LResources, Forms, Controls,
  Graphics, Dialogs, StdCtrls, Grids, DBGrids;

const CST_EXTENSION_DBF  = '.dbf' ;
      CST_NOM_FICHIER    = 'fiches';
      CST_FIELD_NOM = 'Nom' ;
      CST_FIELD_PRENOM = 'Prenom' ;
type

  { TMaFiche }

  TMaFiche = class(TForm)
    Supprimer: TToggleBox;
    DbfNoms: TDbf;
    Noms: TStringGrid;
    Ajouter: TToggleBox;
    Quitter: TToggleBox;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure AjouterChange(Sender: TObject);
    procedure QuitterChange(Sender: TObject);
    procedure SupprimerChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  MaFiche: TMaFiche;

implementation

{ TMaFiche }

procedure TMaFiche.FormShow(Sender: TObject);
begin
  // On cherche ou crée le fichier DBF
  DbfNoms.FilePathFull := ExtractFileDir ( Application.ExeName );
  DbfNoms.TableName:=CST_NOM_FICHIER+CST_EXTENSION_DBF;
  try
    // Un Dataset s'ouvre pour lire et écrire les données
    DbfNoms.Open;
  Except
    // Il s'agit d'une entrée/sortie donc on gère les exceptions
    on e:Exception do
      Begin
       ShowMessage ( 'Impossible d''ouvrir le fichier DBF : ' + E.Message );
       Exit;
      end;
  end;
  // Le with permet de travailler au sein du SdfDataSet
  with DbfNoms do
   try
    // On adapte la grille au fichier DBF
    if Noms.RowCount < RecordCount Then
      Noms.RowCount := RecordCount;
    // On se place au début
    First;
    // Tant que la End Of File n'est pas atteinte on est dans la boucle
    while not EOF do
      Begin
        // Affectation de la grille
        Noms.Cells [ 0, RecNo - 1 ] := FieldByName(CST_FIELD_NOM).AsString;
        Noms.Cells [ 1, RecNo - 1 ] := FieldByName(CST_FIELD_PRENOM).AsString;
        // Enregistrement suivant
        Next;
      end;

   Except
    // Il s'agit d'une entrée/sortie donc on gère les exceptions
    on e:Exception do
      Begin
       ShowMessage ( 'Impossible de lire le fichier DBF : ' + E.Message );
       Exit;
      end;
   end;
end;

procedure TMaFiche.AjouterChange(Sender: TObject);
begin
  Noms.RowCount := Noms.RowCount+1;
end;

procedure TMaFiche.QuitterChange(Sender: TObject);
begin
  Close;
end;

procedure TMaFiche.SupprimerChange(Sender: TObject);
begin
  Noms.DeleteColRow(False,Noms.Row);
end;

procedure TMaFiche.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var li_i : Integer;
begin
  // Avec le SdfDataset
  with DbfNoms do
   Begin
     // On efface les anciennes colonnes
     // Le SdfDataset ne gère pas l'édition
    EmptyTable;
    // On remplit le fichier DBF
    for li_i := 1 to Noms.RowCount -1 do
      Begin
        // Insertion car "Edit" ne marche pas ici
        Insert;
        // On affecte le nom et le prénom
        FieldByName(CST_FIELD_NOM).Value := Noms.Cells [ 0, li_i ];
        FieldByName(CST_FIELD_PRENOM).value := Noms.Cells [ 1, li_i ];
        // Validation de la ligne
        Post;
      end;
    // Validation du fichier
    Updated;
   end;

end;

initialization
  {$I ufiche.lrs}

end.

