unit fonctions_string;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Grids;

function fs_GetAValueFromStringValues ( const ASeparator, AStringInclusion, ACharElude : Char ; var AValues : String ): String;
procedure p_StringGridToStringList ( const AStringGrid : TStringGrid ; const astl_FichierCSV : TStrings );

const CST_SEPARATEUR_CSV = ';' ;
      CST_CHAR_INCLUSION = '"' ;


implementation

uses Dialogs;

// Fonction fs_GetAValueFromStringValues
// Renvoie la première chaine avant le séparateur et l'enlève des valeurs
function fs_GetAValueFromStringValues ( const ASeparator, AStringInclusion, ACharElude : Char ; var AValues : String ): String;
var lpc_PosChar ,
    lpc_LastPosChar,
    lpc_PosEnd  : Pchar ;
    lb_Elude : Boolean;

    // Défilement
  procedure p_Defilement ;
    Begin
      lpc_LastPosChar := lpc_PosChar ;
      inc ( lpc_PosChar );
    end;

Begin
  Result := '';
  if ( AValues    = '' )
  or ( ASeparator = '' ) Then
    Exit;

  // Se positionner sur le premier caractère
  lpc_PosChar := @AValues [ 1 ];
  // Fin de la chaine et du défilement
  lpc_PosEnd  := @AValues [ length ( AValues )];
  if lpc_PosChar^ = AStringInclusion Then
    Begin
      lb_Elude := True;
      inc ( lpc_PosChar );
    end
   else
    lb_Elude := False;
  try
    lpc_LastPosChar := lpc_PosChar;
    // Tant qu'on est sur la chaine
    while lpc_PosChar <= lpc_PosEnd do
      Begin
        if lb_Elude Then
          Begin
            if  ( ACharElude <> ' ' )
            and ( lpc_PosChar = ACharElude ) Then
              Begin
                p_Defilement ;
                Result := Result + lpc_PosChar^;
                p_Defilement ;
                Continue;
              end;
            if lpc_PosChar^ = AStringInclusion Then
              Begin
                inc ( lpc_PosChar );
                if ( lpc_PosChar  > lpc_PosEnd )
                or ( lpc_PosChar^ = ASeparator ) Then
                  Break;
              End;
          End
         else
          // Le caractère de spération est trouvé
          if lpc_PosChar^ = ASeparator Then
            Break;
        // Création du résultat
        AppendStr ( Result, lpc_PosChar^ );
        // Défilement
        p_Defilement ;
      end;
  except
    On E:Exception do
      ShowMessage ( 'Mauvais fichier CSV.'+#13#10+' Le séparateur est '+ASeparator +'.'
      +#13#10+'Les chaines sont inclues entres deux '+ AStringInclusion + ' avec le caractère d''annulation '+ ACharElude + '.' );
  end;
  // Pas de séparation
  if lpc_PosChar <= lpc_PosEnd Then
    // Elusion du résultat dans les valeurs
    AValues := copy ( AValues, length ( Result ), length ( AValues ) - length ( Result ));
end;

procedure p_StringGridToStringList ( const AStringGrid : TStringGrid ; const astl_FichierCSV : TStrings );
var
    ls_uneligne ,
    ls_UneCellule : String;
    li_i, li_j : Integer;
Begin
  // Le tableau a des colonnes mais aussi des lignes
  // AStringGrid.FixedRows est une colonne qui n'est pas modifiable
  for li_j := AStringGrid.FixedRows to AStringGrid.RowCount -1 do
    Begin
      ls_uneligne := '';
    // Sauvegarde des lignes de la grille
      for li_i := AStringGrid.FixedCols to AStringGrid.Columns.Count -1 do
        Begin
          ls_UneCellule := AStringGrid.Cells [ li_i, li_j ];
          ls_UneCellule := StringReplace ( ls_UneCellule, '\', '\\', [rfReplaceAll] );
          ls_UneCellule := StringReplace ( ls_UneCellule, '"', '\"', [rfReplaceAll] );
          if li_i = AStringGrid.FixedCols Then // La première ligne ne possède pas de séparateur
            ls_uneligne := CST_CHAR_INCLUSION+ls_UneCellule+CST_CHAR_INCLUSION
           Else
            ls_uneligne := ls_uneligne + CST_SEPARATEUR_CSV + CST_CHAR_INCLUSION+ls_UneCellule+CST_CHAR_INCLUSION;
        end;
      astl_FichierCSV.Add(ls_uneligne);
    end;
End;

end.

