unit UFiche;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, SdfData, FileUtil, LResources, Forms,
  Controls, Graphics, Dialogs, StdCtrls, Grids, DBGrids;

const CST_EXTENSION_CSV  = '.csv' ;
      CST_FIELD_NOM = 'Nom' ;
      CST_FIELD_PRENOM = 'Prenom' ;
type

  { TMaFiche }

  TMaFiche = class(TForm)
    Noms: TStringGrid;
    Ajouter: TToggleBox;
    Quitter: TToggleBox;
    DataSetNoms: TSDFDataSet;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure AjouterChange(Sender: TObject);
    procedure QuitterChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  MaFiche: TMaFiche;

implementation

{ TMaFiche }

procedure TMaFiche.FormShow(Sender: TObject);
begin
  // On cherche ou crée le fichier CSV
  DataSetNoms.FileName := Application.ExeName + CST_EXTENSION_CSV;
  try
    // Un Dataset s'ouvre pour lire et écrire les données
    DataSetNoms.Open;
  Except
    // Il s'agit d'une entrée/sortie donc on gère les exceptions
    on e:Exception do
      Begin
       ShowMessage ( 'Impossible d''ouvrir le fichier CSV : ' + E.Message );
       Exit;
      end;
  end;
  // Le with permet de travailler au sein du SdfDataSet
  with DataSetNoms do
   try
    // On adapte la grille au fichier CSV
    if Noms.RowCount < RecordCount Then
      Noms.RowCount := RecordCount;
    // On se place au début
    First;
    // Tant que la End Of File n'est pas atteinte on est dans la boucle
    while not EOF do
      Begin
        // Affectation de la grille
        Noms.Cells [ 0, RecNo - 1 ] := Fields[0].AsString;
        Noms.Cells [ 1, RecNo - 1 ] := Fields[1].AsString;
        // Enregistrement suivant
        Next;
      end;

   Except
    // Il s'agit d'une entrée/sortie donc on gère les exceptions
    on e:Exception do
      Begin
       ShowMessage ( 'Impossible de lire le fichier CSV : ' + E.Message );
       Exit;
      end;
   end;
end;

procedure TMaFiche.AjouterChange(Sender: TObject);
begin
  Noms.RowCount := Noms.RowCount+1;
end;

procedure TMaFiche.QuitterChange(Sender: TObject);
begin
  Close;
end;

procedure TMaFiche.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var li_i : Integer;
begin
  // Avec le SdfDataset
  with DataSetNoms do
   Begin
     // On efface les anciennes colonnes
     // Le SdfDataset ne gère pas l'édition
    First;
    while not EOF do
      Delete;
    // On remplit le fichier CSV
    for li_i := 1 to Noms.RowCount -1 do
      Begin
        // Insertion car "Edit" ne marche pas ici
        Insert;
        // On affecte le nom et le prénom
        Fields[0].Value := Noms.Cells [ 0, li_i ];
        Fields[1].value := Noms.Cells [ 1, li_i ];
        // Validation de la ligne
        Post;
      end;
   end;

end;

initialization
  {$I ufiche.lrs}

end.

