unit UFiche;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, SdfData, db, FileUtil, LResources, Forms, Controls,
  Graphics, Dialogs, StdCtrls, Grids, DBGrids;

type

  { TMaFiche }

  TMaFiche = class(TForm)
    Datasource: TDatasource;
    Noms: TDBGrid;
    Quitter: TToggleBox;
    SdfDataSetNoms: TSdfDataSet;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure QuitterChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  MaFiche: TMaFiche;

implementation

uses fonctions_string;

{ TMaFiche }

procedure TMaFiche.FormShow(Sender: TObject);
var stl_FichierCSV : TStringlist ;
    ls_uneligne : String;
    li_i, li_j : Integer;
begin
  if FileExists(Application.ExeName + CST_EXTENSION_CSV) Then
    Begin
      stl_FichierCSV := TStringlist.Create ( );
        try
          stl_FichierCSV.LoadFromFile ( Application.ExeName + CST_EXTENSION_CSV );
        Except
          On E:Exception do
            Showmessage ( 'Impossible de lire le fichier ' +  Application.ExeName + CST_EXTENSION_CSV + ':'+#13#10 + E.Message );
        end;
    End
   else
    Exit;
  if stl_FichierCSV.Count = 0 Then
    Exit;
  ls_uneligne := stl_FichierCSV [ 0 ];
  // Sauvegarde des noms de colonnes : Nous ne sommes pas obligés de le faire
  for li_i := 0 to Noms.Columns.Count -1 do
    Begin
      Noms.Columns [ li_i ].Title.Caption := fs_GetAValueFromStringValues ( CST_SEPARATEUR_CSV, CST_CHAR_INCLUSION, '\', ls_uneligne );
    end;
  // Le tableau a des colonnes mais aussi des lignes
  // Noms.FixedRows est une colonne qui n'est pas modifiable
  for li_j := Noms.FixedRows to Noms.RowCount -1 do
    Begin
      if  Noms.RowCount -1 -Noms.FixedRows >= stl_FichierCSV.Count Then
        Break;
      ls_uneligne := stl_FichierCSV [ Noms.RowCount -1 -Noms.FixedRows ];
    // Sauvegarde des lignes de la grille
      for li_i := Noms.FixedCols to Noms.Columns.Count -1 do
        Begin
          Noms.Cells [ li_i, li_j ] :=  fs_GetAValueFromStringValues ( CST_SEPARATEUR_CSV, CST_CHAR_INCLUSION, '\', ls_uneligne );
        end;
    end;
  stl_FichierCSV.Free;
end;

procedure TMaFiche.QuitterChange(Sender: TObject);
begin
  Close;
end;

procedure TMaFiche.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var stl_FichierCSV : TStringlist ;
    ls_uneligne ,
    ls_UneCellule : String;
    li_i : Integer;
begin
  // Pas de colonne donc pas de ligne donc on quitte
  if Noms.Columns.Count = 0 Then
    Exit;

  stl_FichierCSV := TStringlist.Create (  );

  // Sauvegarde des noms de colonnes : Nous ne sommes pas obligés de le faire
  for li_i := 0 to Noms.Columns.Count -1 do
    Begin
      if li_i = 0 Then // La première ligne ne possède pas de séparateur
        ls_uneligne := CST_CHAR_INCLUSION+Noms.Columns [ li_i ].Title.Caption+CST_CHAR_INCLUSION
       Else
        ls_uneligne := ls_uneligne + CST_SEPARATEUR_CSV + CST_CHAR_INCLUSION + Noms.Columns [ li_i ].Title.Caption + CST_CHAR_INCLUSION;
    end;
  stl_FichierCSV.Add(ls_uneligne);
  p_StringGridToStringList ( Noms, stl_FichierCSV );
  try
    stl_FichierCSV.SaveToFile(Application.ExeName + CST_EXTENSION_CSV);
  Except
    On E:Exception do
      Showmessage ( 'Impossible d''écrire dans le fichier ' +  Application.ExeName + CST_EXTENSION_CSV + ':'+#13#10 + E.Message );
  End;
  stl_FichierCSV.Free;

end;

initialization
  {$I ufiche.lrs}

end.

