unit F_Convertir;

{$IFDEF FPC}
{$MODE Delphi}
{$ENDIF}

interface

uses
  {Windows,} Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl, ExtCtrls, LResources, EditBtn, U_OnFormInfoIni;

type

  { TForm1 }

  TForm1 = class(TForm)
    DirectoryListBox: TDirectoryEdit;
    OnFormInfoIni1: TOnFormInfoIni;
    Panel1: TPanel;
    DirectoryEdit: TDirectoryEdit;
    FileListBox: TFileListBox;
    Convertir: TButton;
    FilterComboBox: TFilterComboBox;
    Messages: TMemo;
    procedure ConvertirClick(Sender: TObject);
    procedure DirectoryEditChange(Sender: TObject);
    procedure FilterComboBoxChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    procedure ConvertitLigneDFMPAS(var as_Ligne: WideString);
    { Dclarations prives }
  public
    procedure ConvertitLignePAS( var ast_Lignes : TStringList; as_Lignes : WideString; const as_Fichier : String ); virtual;
    procedure ConvertitLigneDFM( var asl_Lignes : TStringList; as_Lignes : WideString; const as_Fichier : String ); virtual;
    procedure ConvertitColumn( var asl_Lignes: TStringList; const as_Ligne : WideString; var li_pos1,li_pos2, li_endcol : Longint ; const li_noData : Longint );
    procedure ConvertitFichier ( const FilePath, FileName  : String );
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation


uses StrUtils;

procedure TForm1.ConvertirClick(Sender: TObject);
var li_i : Integer ;
begin
  Messages.Lines.Clear;
  Messages.Lines.Add( '-> Parcourt de ' + DirectoryEdit.Directory );
  For Li_i := 0 To FileListBox.Items.Count - 1 do
    Begin
      ConvertitFichier ( DirectoryEdit.Directory + DirectorySeparator + FileListBox.Items.Strings [ li_i ], FileListBox.Items.Strings [ li_i ] );
    End ;
  Messages.Lines.Add ( '-> Fin pour ' + DirectoryEdit.Directory + '.' );
end;

procedure TForm1.DirectoryEditChange(Sender: TObject);
begin
  FileListBox.Directory := DirectoryEdit.Directory ;
end;

procedure TForm1.FilterComboBoxChange(Sender: TObject);
begin
  FileListBox.Mask := FilterComboBox.Mask;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if DirectoryEdit.Directory = '' Then
    DirectoryEdit.Directory:= GetCurrentDir;
end;

procedure TForm1.ConvertitFichier(const FilePath, FileName : String);
var li_i : Integer ;
    ls_Lignes : WideString ;
    lb_DFM ,
    lb_LFM : Boolean ;
    lst_Lignes : TWideStringList ;
begin
  lb_DFM := PosEx ( '.dfm', LowerCase ( FilePath ), length ( FilePath ) - 5 ) >= length ( FilePath ) - 5 ;
  lb_LFM := PosEx ( '.lfm', LowerCase ( FilePath ), length ( FilePath ) - 5 ) >= length ( FilePath ) - 5 ;
  lst_Lignes := TStringList.Create;
  try
    lst_Lignes.BeginUpdate;
    lst_Lignes.LoadFromFile ( FilePath );
    ls_Lignes := lst_Lignes.Text;

    Application.ProcessMessages;


    // Conversion Extended
    ls_Lignes := StringReplace ( ls_Lignes, 'TADOTable', 'TZQuery', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TADOQuery', 'TZQuery', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'adot_', 'zq_', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'dxButton', 'JvXpButton', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'Windows,', 'LCLType,', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'LCLType,', '{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'adoq_', 'zq_', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TRxDBLookupCombo', 'TFWDBLookupCombo', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TJvDBLookupCombo', 'TFWDBLookupCombo', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'fonctions_Objets_Dynamiques', 'fonctions_Objets_Data', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'fonctions_db,', 'fonctions_dbcomponents,', [rfReplaceAll,rfIgnoreCase] );

     if lb_DFM
     or lb_LFM Then
       ConvertitLigneDFM ( lst_Lignes, ls_Lignes, FilePath )
      else
       ConvertitLignePAS ( lst_Lignes, ls_Lignes, FilePath );

    Application.ProcessMessages;
  finally
    lst_Lignes.EndUpdate;
    lst_Lignes.SaveToFile   ( FilePath );
    lst_Lignes.Free;

  end;
    Messages.Lines.Add ( '  - Fichier ' + FileName + ' converti...' );
end;

procedure TForm1.ConvertitLignePAS( var ast_Lignes : TStringList ; as_Lignes : WideString; const as_Fichier : String );
var li_pos1 : Longint;
    ls_Ligne : WideString;
begin
         {
  // FOMR DICO
  as_Lignes := StringReplace ( as_Lignes, 'Data2NavEdit', 'Columns[1].NavEdit', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'ControlFocus3', 'Columns[2].ControlFocus', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data2LookupField', 'Columns[1].LookupField', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data2Key', 'Columns[1].Key', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data2Table', 'Columns[1].Table', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data2Panel', 'Columns[1].Panel', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data2Navigator', 'Columns[1].Navigator', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data3NavEdit', 'Columns[2].NavEdit', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'ControlFocus3', 'Columns[1].ControlFocus', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data3LookupField', 'Columns[2].LookupField', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data3Key', 'Columns[2].Key', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data3Table', 'Columns[2].Table', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data3Panel', 'Columns[2].Panel', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data3Navigator', 'Columns[2].Navigator', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DataNavigator', 'Columns[0].Navigator', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DataNavEdit', 'Columns[0].NavEdit', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DataTable', 'Columns[0].Table', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DataKey', 'Columns[0].Key', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'ControlFocus', 'Columns[0].ControlFocus', [rfReplaceAll,rfIgnoreCase] );

  as_Lignes := StringReplace ( as_Lignes, 'Datasource2', 'Columns[1].Datasource', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Datasource3', 'Columns[2].Datasource', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, ' Datasource', 'Columns[0].Datasource', [rfReplaceAll,rfIgnoreCase] );
{
  as_Lignes := StringReplace ( as_Lignes, 'DBGridLookupDatasource', 'Datasource3', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DBSortDataset', 'DataOnSort', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DBGridLookupNavigator', 'Data2NavEdit', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DBGridLookupKey', 'Data2LookupField', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DBGridLookupTable', 'Data3Table', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Datasource2Key', 'Data2Key', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Datasource2Table', 'Data2Table', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Datasource2Panel', 'Data2Panel', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Datasource2Navigator', 'Data2Navigator', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DBNavigatorEditor', 'DataNavEdit', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DatasourceTable', 'DataTable', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DatasourceKey', 'DataKey', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DBGridNavigator', 'DataNavigator', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'WorkDatasource', 'Datasource4', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'WorkDatasourceTable', 'Data4Table', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'WorkDataTable', 'Data4Table', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'WorkDataGrid', 'Data4Grid', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'WorkDatasourceKey', 'Data4Key', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'WorkDataKey', 'Data4Key', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'WorkDBGrid', 'Data4Grid', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'WorkNavigatorEdit', 'Data4NavEdit', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'WorkNavigator', 'Data4Navigator', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'WorkDatasourceNavigator', 'Data4Navigator', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'WorkDataNavigator', 'Data4Navigator', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'WorkControlFocus', 'ControlFocus4', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DataGridLookupField', 'Data3LookupField', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DataGridOnScroll', 'Data2OnScroll', [rfReplaceAll,rfIgnoreCase] );
}
{  ast_Lignes.Text := as_Lignes;
  li_pos1 := -1;
  ast_Lignes.EndUpdate;
  while li_pos1 < ast_Lignes.Count -1 do
    Begin
      Application.ProcessMessages;
      inc ( li_pos1 );
      ls_Ligne := ast_Lignes [ li_pos1 ];
      ConvertitLigneDFMPAS ( ls_Ligne );
      ast_Lignes [ li_pos1 ]:=ls_Ligne;

    End;}
end;

procedure TForm1.ConvertitLigneDFMPAS( var as_Ligne : WideString );
var ls_ligne : String ;
begin

      ls_Ligne := lowercase ( as_ligne );
      if ( pos ( '_ferme', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWClose', [rfIgnoreCase] );

      if ( pos ( '_quit', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWQuit', [rfIgnoreCase] );

      if ( pos ( '_copie', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWCopy', [rfIgnoreCase] );

      if ( pos ( '_aperc', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWPreview', [rfIgnoreCase] );

      if ( pos ( 'bt_enr', ls_Ligne)> 0 )
      or ( pos ( 'bt_ok' , ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWOK', [rfIgnoreCase] );

      if ( pos ( '_init', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWInit', [rfIgnoreCase] );

      if ( pos ( '_insert', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWInsert', [rfIgnoreCase] );

      if ( pos ( 'in_total', ls_Ligne)> 0 )
      or ( pos ( 'intot', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWInAll', [rfIgnoreCase] );

      if ( pos ( 'out_total', ls_Ligne)> 0 )
      or ( pos ( 'outtot', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWOutAll', [rfIgnoreCase] );

      if ( pos ( 'bt_in', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWInSelect', [rfIgnoreCase] );

      if ( pos ( 'bt_out', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWOutSelect', [rfIgnoreCase] );

      if ( pos ( '_annul', ls_Ligne)> 0 )
      or ( pos ( '_aband', ls_Ligne)> 0 )
      or ( pos ( '_cancel', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWCancel', [rfIgnoreCase] );

      if ( pos ( '_imprim', ls_Ligne)> 0 )
      or ( pos ( '_print', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWPrint', [rfIgnoreCase] );


end;
procedure TForm1.ConvertitLigneDFM( var asl_Lignes: TStringList; as_Lignes : WideString; const as_Fichier : String );
var li_pos1, li_pos2, li_pos3 : LongInt;
    ls_Table : String;
    ls_Ligne, ls_Compare : WideString;
begin
  li_pos1:= 0;
      while ( PosEx ( 'TableName', as_Lignes, li_pos1 + 1 ) > li_pos1 ) do
        Begin
          li_pos1 := posEx ( 'TableName', as_Lignes, li_pos1 + 1 );
          li_pos2 := Posex ( '''', as_Lignes, li_pos1);
          li_pos3 := Posex ( '''', as_Lignes, li_pos2 +1);
          ls_Table := copy ( as_Lignes, li_pos2 + 1 , li_pos3 - 1 -li_pos2 );
    //      Showmessage ( ls_Table+ ' '+inttoStr ( li_pos2 )+ ' '+inttoStr ( li_pos3 ));
          as_Lignes := copy ( as_Lignes, 1, li_pos2 - 1) + '(''SELECT * FROM ' + ls_Table + ''')' +  copy ( as_Lignes, li_pos3 + 1, length ( as_Lignes ) - li_pos3 );
        End;
      as_Lignes := StringReplace ( as_Lignes, 'TableName', 'SQL.Strings', [rfReplaceAll,rfIgnoreCase] );
  li_pos2 := -1;
  li_pos1 := -1;
  asl_Lignes.Text := as_Lignes ;
  asl_Lignes.EndUpdate;
{  while li_pos1 < asl_Lignes.Count -1 do
    Begin
      Application.ProcessMessages;
      inc ( li_pos1 );
      ls_Ligne := asl_Lignes [ li_pos1 ];
      ls_Compare := ls_ligne;


      as_Ligne := StringReplace ( as_Ligne, 'Data4NavEdit', 'NavEdit', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'ControlFocus4', 'ControlFocus', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Data4LookupField', 'LookupField', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Data4Key', 'Key', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Data4Table', 'Table', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Data4Panel', 'Panel', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Data4Navigator', 'Navigator', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Datasource4', 'Datasource', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Data4Grid', 'Grid', [rfIgnoreCase] );

      if ( length ( ls_Ligne ) <> length ( ls_Compare ))
       then
        Begin
          ConvertitColumn ( asl_lignes,ls_ligne,li_pos1, li_pos2, li_pos3, 3 );
          Continue;
        End;

      as_Ligne := StringReplace ( as_Ligne, 'Data2NavEdit', 'NavEdit', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'ControlFocus3', 'ControlFocus', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Data2LookupField', 'LookupField', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Data2Key', 'Key', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Data2Table', 'Table', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Data2Panel', 'Panel', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Data2Navigator', 'Navigator', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Datasource2', 'Datasource', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Data2Grid', 'Grid', [rfIgnoreCase] );

      if ( length ( ls_Ligne ) <> length ( ls_Compare ))
       then
        Begin
          ConvertitColumn ( asl_lignes,ls_ligne, li_pos1, li_pos2, li_pos3, 1 );
          Continue;
        End;

      as_Ligne := StringReplace ( as_Ligne, 'Data3NavEdit', 'NavEdit', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'ControlFocus3', 'ControlFocus', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Data3LookupField', 'LookupField', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Data3Key', 'Key', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Data3Grid', 'Grid', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Data3Table', 'Table', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Data3Panel', 'Panel', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Data3Navigator', 'Navigator', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'Datasource3', 'Datasource', [rfIgnoreCase] );

      if ( length ( ls_Ligne ) <> length ( ls_Compare ))
       then
        Begin
          ConvertitColumn ( asl_lignes,ls_ligne, li_pos1, li_pos2, li_pos3, 2 );
          Continue;
        End;



      as_Ligne := StringReplace ( as_Ligne, 'DataNavigator', 'Navigator', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'DataNavEdit', 'NavEdit', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'DataGrid', 'Grid', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'DataTable', 'Table', [rfIgnoreCase] );
      as_Ligne := StringReplace ( as_Ligne, 'DataKey', 'Key', [rfIgnoreCase] );
      if ( pos ( '  datasource', ls_Ligne) in [ 1..2] ) then
        as_Ligne := StringReplace ( as_Ligne, 'Datasource =', '    Datasource =', [rfIgnoreCase] );
      if ( pos ( '  controlfocus', ls_Ligne) in [ 1..2] ) then
        as_Ligne := StringReplace ( as_Ligne, 'ControlFocus', '    ControlFocus', [rfIgnoreCase] );

      if ( length ( ls_Ligne ) <> length ( ls_Compare ))
       then
        Begin
          ConvertitColumn ( asl_lignes,ls_ligne, li_pos1, li_pos2, li_pos3, 0 );
          Continue;
        End;

      if ( pos ( 'groupview', ls_Ligne)> 0 ) then
        Break;
      asl_Lignes [ li_pos1 ] := ls_ligne;
    End;}
{  li_pos1 := -1;
  asl_Lignes.EndUpdate;
  while li_pos1 < asl_Lignes.Count -1 do
    Begin
      Application.ProcessMessages;
      inc ( li_pos1 );
      ls_Ligne := asl_Lignes [ li_pos1 ];
      ConvertitLigneDFMPAS ( ls_Ligne );
      asl_Lignes [ li_pos1 ]:=ls_Ligne;

    End;
 }
end;
procedure TForm1.ConvertitColumn( var asl_Lignes: TStringList; const as_Ligne : WideString; var li_pos1,li_pos2, li_endcol : Longint ; const li_noData : Longint );
var li_Item, li_Counter, li_noItem : Longint;
    lb_Found : Boolean;
Begin
  if li_pos2 > 0 then
    Begin
      if ( li_pos1 < asl_lignes.count ) then
        asl_Lignes.Delete ( li_pos1 );
      if  ( li_noData = 0 ) Then
        Begin
          if ( li_pos2 + 2 < asl_lignes.count ) then
            Begin
              asl_Lignes.Insert ( li_pos2 + 2, as_ligne ) ;
            End;
        End
      else
        Begin
          li_noItem := -1;
          lb_Found := False ;
          li_Item  := li_pos2;
          for li_Counter := li_pos2 to asl_Lignes.Count - 1 do
            Begin
              if pos ( '  end>', asl_Lignes [ li_counter ])>0 then
                Begin
                  li_Item  := li_counter;
                  Break;
                End;
              if pos ( ' Item', asl_Lignes [ li_counter ])>0 then
                Begin
                  inc(li_noItem);
                  if ( li_noitem = li_noData ) then
                    Begin
                      lb_Found := True ;
                      asl_Lignes.Insert( li_counter +1, as_ligne );
                      Break;
                    End;

                End;
            End;
          if not lb_found then
            Begin
              asl_Lignes.Insert ( li_Item, as_Ligne );
              asl_Lignes.Insert ( li_Item, '    Item' );
              inc( li_endCol );
              if ( pos ( 'end', asl_lignes [ li_Item - 1 ])=0) then
                Begin
                  asl_Lignes.Insert ( li_Item, '    end' );
                  inc ( li_Item );
                  inc( li_endCol );
                End;

              if ( li_item < asl_lignes.count ) then
                for li_counter := li_noitem + 2  to li_noData do
                  Begin
                    asl_Lignes.Insert ( li_Item, '    end' );
                    asl_Lignes.Insert ( li_Item, '    Item' );
                    inc( li_endCol, 2 );
                  End;

            End;
        End;
    End
  else
    Begin
      li_pos2 := li_pos1 ;
      li_endCol :=li_pos2;
      asl_Lignes [ li_pos1 ] := as_ligne;
      if ( li_pos2 < asl_lignes.count ) then
        Begin
          asl_Lignes.Insert ( li_pos2+1, '    end>' );
          asl_Lignes.Insert ( li_pos2, '    Item' );
          asl_Lignes.Insert ( li_pos2, '  Columns = <' );
          inc( li_endCol, 3 );
          for li_counter := 0 to li_noData -1 do
            Begin
              asl_Lignes.Insert ( li_pos2+1, '    end' );
              asl_Lignes.Insert ( li_pos2+1, '    Item' );
              inc( li_endCol, 2 );
            End;
        End;
    End ;
 li_pos1 := li_endcol;
end;

initialization
  {$i F_Convertir.lrs}
  {$i F_Convertir.lrs}

end.
